
 ;12(b) Develop and execute an Assembly Language program to scan a
 ;      4 X 4 keypad interface for key closer. The row number and
 ;      column number of the key pressed are to be stored in memory
 ;      locations.
  
        .MODEL SMALL
	.STACK
	.DATA
           PA EQU 120H
           PB EQU 121H
           PC EQU 122H
           CR EQU 123H
	   M1  DB  0AH,0DH," ROW NUMBER IS: $"
	   M2  DB  0AH,0DH,"COLUMN NUMBER IS:$"
	   M3  DB  0AH,0DH,"PRESS 'C' TO CONTINUE$"
	  
        .CODE
                MOV AX,@DATA
		MOV DS,AX
		MOV AL,90H
		MOV DX,CR
                OUT DX,AL    ;Initialize 8255 PPI
          START:
                MOV AL,80H
                MOV CL,1
		MOV CH,1
		MOV BL,3

        NEXTROW:
                ROL AL,1
		MOV AH,AL
		MOV DX,PC
                OUT DX,AL   ;Enable Row
		MOV BH,8
		MOV DX,PA
		IN AL,DX
        NEXTCOL:
                ROR AL,1
                JC DISPLAY   ;Check for key closer
		INC CL
		DEC BH
		JNZ NEXTCOL
		MOV CL,1
		INC CH
		MOV AL,AH
		DEC BL
		JNZ NEXTROW
		JMP START
       DISPLAY: ADD CX,3030H   ;Convert from digit to ASCII
		LEA DX,M1
                MOV AH,9       ;Display  Message.
		INT 21H
		MOV DL,CH
		MOV AH,2
		INT 21H
		LEA DX,M2
		MOV AH,9
		INT 21H
		MOV DL,CL
		MOV AH,2
		INT 21H
		LEA DX,M3
		MOV AH,9
		INT 21H
		MOV AH,8
		INT 21H
		CMP AL,'C'
		JZ START
		MOV AH,4CH
		INT 21H
		END
										     
