
;5(b) Develop and execute an ALP to read the status of two inputs from
;     the logic controller interface and to display the output of 2
;     boolean expressions of the two inputs, using the same interface.
;     (The two boolean expressions are to be specified by the examiner.)
       Assume Half Adder
          SUM = X EX-OR Y  CARRY= XY.

         .MODEL SMALL
         .STACK
         .DATA
           PA EQU 120H
           PB EQU 121H
           PC EQU 122H
           CR EQU 123H
         .CODE
            MOV AX,@DATA
            MOV DS,AX
            MOV AL,82H
            MOV DX,CR
            OUT DX,AL
            MOV DX,PB
            IN AL,DX     ;Read the data from LC
            AND AL,03H
            MOV CL,AL
            AND CL,01H   ;bit x
            MOV CH,AL
            AND CH,02H
            SHR CH,1     ;bit y
            MOV AL,CL
            XOR AL,CH   ;Sum bit=x exor y
            MOV AH,CL
            AND AH,CH   ;Carry bit= x and y
            SHL AH,1
            OR AL,AH
            MOV DX,PA
            OUT DX,AL  ; Display the output, PA0=SUM, PA1=CARRY 
            MOV AH,4CH
            INT 21H
            END




