
;10(b) Develop and execute an Assembly Language program to drive the
;       Elevator interface in the following way:
;     Assume that initially the elevator is at ground floor and all service
;      requests are cleared.The elevator stays in the ground floor as
;      long as there is no service reguest. When a service reguest is
;      detected, the elevator moves to that floor. While it is travelling to
;      that floor,if a service request is detected for any intermediate floor,
;      it is also serviced(the floor request LED is turned off.)After
;      servicing the floor for which the request was first registred,the
;      elevator  returns to ground floor ignoring all further requests.
;           The delays to simulate the elevator motion,the delay indicating
;      the servicing of a request can be any arbitrary values.Examiner
;      doesn't specify these values, nor is the student required to
;      calculate them.
   .MODEL SMALL
   .STACK
   .DATA
          PA EQU 120H
	  PB EQU 121H
	  PC EQU 122H
	  CR EQU 123H
	    
  .CODE
           MOV AX,@DATA
           MOV DS,AX
           MOV AL,82H
           MOV DX,CR
           OUT DX,AL
    START: MOV BL,0
           MOV AL,BL
	   OR AL,0F0H
	   MOV DX,PA
	   OUT DX,AL
	   CALL CHK
	   MOV CH,AL
	   MOV CL,4
	   SHR AL,CL
	   JNC TFR
	   MOV AL,CH
	   MOV CL,3
	   SHR AL,CL
	   JNC SFR
	   MOV AL,CH
	   MOV CL,2
	   SHR AL,CL
	   JNC FFR
	   MOV AL,CH
	   SHR AL,1
	   JC START
	   MOV AL,0E0H
	   MOV DX,PA
	   OUT DX,AL
	   JMP START
     FFR:  CALL DELAY
           INC BL
	   MOV AL,BL
	   OR AL,0F0H
	   MOV DX,PA
	   OUT DX,AL
	   CMP BL,3
	   JNZ FFR
	   MOV AL,0D3H
	   MOV DX,PA
	   OUT DX,AL
	   JMP DOWN
       SFR:CALL DELAY
           INC BL
	   MOV AL,BL
	   OR AL,0F0H
	   MOV DX,PA
	   OUT DX,AL
	   CMP BL,3
	   JNZ NEXT
	   CALL C_11
      NEXT:CMP BL,6
           JNZ SFR
	   MOV AL,0B6H
	   MOV DX,PA
	   OUT DX,AL
	   JMP DOWN
       TFR:CALL DELAY
           INC BL
	   MOV AL,BL
	   OR AL,0F0H
	   MOV DX,PA
	   OUT DX,AL
	   CMP BL,3
	   JNZ FFF
	   CALL C_11
       FFF:CMP BL,6
           JNZ SSS
	   CALL C_22
       SSS:CMP BL,9
           JZ GND
           JMP TFR
      C_11:CALL CHK
           OR AL,0FDH
	   MOV CL,2
	   SHR AL,CL
	   JNC R_11
	   RET
      C_22:CALL CHK
           OR AL,0FBH
	   MOV CL,3
	   SHR AL,CL
	   JNC R_22
	   RET
     R_11: MOV AL,0D3H
           MOV DX,PA
	   OUT DX,AL
	   CALL DELAY
	   RET
      R_22:MOV AL,0B6H
           CALL DELAY
	   MOV DX,PA
	   OUT DX,AL
	   RET
       GND:MOV AL,79H
           MOV DX,PA
	   OUT DX,AL
      DOWN:CALL DELAY
           MOV AL,BL
	   OR AL,0F0H
	   OUT DX,AL
	   DEC BL
	   CMP BL,0FFH
	   JNZ DOWN
	   MOV Ah,4ch
           INT 21h
     CHK:  MOV DX,PB
           IN AL,DX
	   OR AL,0F0H
	   CMP AL,0FFH
	   JZ CHK
	   RET
    DELAY: PUSH BX
           PUSH CX
           MOV BX,099h
       B2: MOV CX,0FFFFH
       B1: LOOP B1
           DEC BX
           JNZ B2
           POP CX
           POP BX
           RET
           END                                                                                                     
