; 1(b) Develop and execute an Assembly Language program to drive a stepper
;      motor interface to rotate the motor in Anticlockwise direction by N
;      steps. (N is specified by the examiner). Introduce suitable delay
;      between successive steps.( The delay is not to be specified by
;      the examiner. The student need not compute the delay. It can be
;      any arbitrary value that just permits the steps of the motor
;      rotation to be counted.)

     .MODEL SMALL
     .STACK
     .DATA
       PA EQU 124H
       PB EQU 125H
       PC EQU 126H
       CR EQU 127H
       STEP_SIZE  DB  35
      .CODE
          MOV AX,@DATA
          MOV DS,AX      ;Initialize data segment
          MOV AL,80H     ;Initialize 8255 PPI
          MOV DX,CR
          OUT DX,AL
          MOV BL,STEP_SIZE
          MOV AL,88H        ;Bit pattern for stepper motor
          MOV DX,PA
    BACK: OUT DX,AL
          CALL DELAY
          ROL AL,1          ;Anticlockwise direction
          DEC BL            ;Reduce the step size
          JNZ BACK
          MOV AH,4CH
          INT 21H
     DELAY   PROC NEAR
            PUSH BX
            MOV BX,01FEH
         B2:MOV CX,0FFFFH    ;It generates the delay of 1.0 Sec opprly.
         B1:LOOP B1
            DEC BX
            JNZ B2
            POP BX
            RET
       DELAY  ENDP
            END

