
;  4(b)  Develop and execute an Assembly Language program to generate a
;        Triangular wave form Using a DAC interface.(The output of
;        the DAC is to be displayed on a  CRO.The slope can be any
;        arbitrary value. No need to compute this value.)

    .MODEL SMALL
    .STACK
    .DATA
        PA EQU 124H
        PB EQU 125H
        PC EQU 126H
        CR EQU 127H
    .CODE
        MOV AX,@DATA
        MOV DS,AX
        MOV AL,80H
        MOV DX,CR
        OUT DX,AL   ;Initialize 8255 PPI
        MOV DX,PA
        MOV AL,00H
   RISE:OUT DX,AL    ;Positive Slope
        INC AL
        CMP AL,0FFH
        JNZ RISE
   FALL:OUT DX,AL     ;Negative Slope
        DEC AL
        CMP AL,00H
        JNZ FALL
        JMP RISE
        END

