
  ;9(b)  Develop and execute an ALP to scan a 4 X 4 Keypad for key closure
  ;      and to store the code of the key pressed in a memory location or
  ;      Display it on the screen. 
  
    .MODEL SMALL
    .STACK
    .DATA
      PA EQU 120H
      PB EQU 121H
      PC EQU 122H
      CR EQU 123H
      M1  DB  0AH,0DH,"ENTERED KEY IS:$"
      M2  DB  0AH,0DH,"PRESS 'C' TO CONTINUE$"
	  
     .CODE
               MOV AX,@DATA
               MOV DS,AX      ;Initialize data segment
               MOV AL,90H
               MOV DX,CR
               OUT DX,AL     ;Initialize 8255 PPI
         START:MOV AL,80H
               MOV CH,0
               MOV BL,3
       NEXTROW:ROL AL,1
               MOV BH,AL
               MOV DX,PC
               OUT DX,AL
               MOV CL,8
               MOV DX,PA
               IN AL,DX
       NEXTCOL:ROR AL,1
               JC DISPLAY
               INC CH
               DEC CL
               JNZ NEXTCOL
               MOV AL,BH
               DEC BL
               JNZ NEXTROW
               JMP START
       DISPLAY:LEA DX,M1
               MOV AH,9
               INT 21H
               MOV DL,CH
               CMP DL,0AH
               JC DIGIT
               ADD DL,07H
        DIGIT: ADD DL,30H
               MOV AH,2
               INT 21H
               LEA DX,M2
               MOV AH,9
               INT 21H
               MOV AH,8
               INT 21H
               CMP AL,'C'
               JZ START
               MOV AH,4CH
               INT 21H
               END
				
												     
